/*
 * @(#CPNTextTool.java 1.0
 *
 */

package CH.ifa.draw.cpn;

import java.awt.*;
import java.awt.event.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.FloatingTextField;
import de.renew.shadow.*;

public class CPNTextTool extends ConnectedTextTool {

    private CPNTextFigure fTextFigure=null;
    private CPNDrawing fDrawing=null;

    public CPNTextTool(DrawingEditor editor, CPNTextFigure prototype) {
        super(editor, prototype);
    }

    public void beginEdit(TextHolder figure) {
        super.beginEdit(figure);
	fTextFigure = (CPNTextFigure)figure;
        fDrawing=(CPNDrawing)fEditor.drawing();
    }

    public void endEdit() {
      super.endEdit();
      if (fTextFigure!=null) {
	CPNTextFigure textFigure=fTextFigure;
	fTextFigure=null;
	if (textFigure.getType()==CPNTextFigure.INSCRIPTION) {
	  String newText=textFigure.getText();
	  if (newText.length()>0) {
	    //System.out.println("New inscription: "+newText);
	    try {
	      if (textFigure instanceof DeclarationFigure) {
		fEditor.showStatus("Checking Declaration Node...");
		CPNDrawing.compiler.checkDeclarationNode(newText);
	      } else {
		ShadowHolder parent = (ShadowHolder)textFigure.parent();
		ShadowNet shadowNet =
                  ((CPNDrawing)view().drawing()).getShadowNet();
		if (parent != null && shadowNet != null) {
		  if (parent instanceof TransitionFigure) {
		    fEditor.showStatus("Checking Transition Inscription...");
		    CPNDrawing.compiler.checkTransitionInscription(newText,
		      shadowNet);
		  } else if (parent instanceof PlaceFigure) {
		    fEditor.showStatus("Checking Place Inscription...");
		    CPNDrawing.compiler.checkPlaceInscription(newText,
		      shadowNet);
		  } else if (parent instanceof ArcConnection) {
		    fEditor.showStatus("Checking Arc Inscription...");
		    CPNDrawing.compiler.checkArcInscription(newText,
		      shadowNet);
		  }
		}
	      }
	    } catch (SyntaxException e) {
	      fEditor.showStatus("A syntax error occured.");
	      ((CPNApplication)fEditor).processSyntaxException(
		new FigureException(e,fDrawing,textFigure),false);
	      //System.out.println(e.toString());
	    }
	  }
	}
      }
    }

}
