/*
 * @(#)DeclarationFigure.java 5.1
 *
 */

package CH.ifa.draw.cpn;

import java.awt.*;
import java.util.*;
import java.io.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import de.renew.simulator.*;
import de.renew.shadow.*;

public class DeclarationFigure extends CPNTextFigure
                               implements ShadowHolder
{
  /*
   * Serialization support.
   */
  private static final long serialVersionUID = -7877776241236946511L;
  private int declFigureSerializedDataVersion = 1;
  
  public DeclarationFigure() {
    super(INSCRIPTION);
  }
  
  private ShadowDeclarationNode shadow = null;
  private ShadowNet net = null;

  public void buildShadow(ShadowNet net) {
    this.net = net;
    // Only create the shadow when the net is not null.
    // Reason: By the way of setText() this method might be called
    // before the net is known. This is an architecture problem.
    if (net!=null) {
      shadow = new ShadowDeclarationNode(net,getText());
      try {
	shadow.syntaxCheck();
      } catch (SyntaxException e) {
	e.printStackTrace();
      }
    }
  }

  public Figure locateShadow(Object shadow) {
    if (shadow==this.shadow) {
      return this;
    } else {
      return null;
    }
  }

  public void setText(String newText) {
    super.setText(newText);
    discardShadow();
    buildShadow(net);
  }

  public void updateInscriptions() throws SyntaxException {   }

  public ShadowNetElement getShadow() { return shadow; }

  private void discardShadow() {
    if (shadow != null) {
      shadow.discard();
      shadow = null;
      //System.err.println("declaration node shadow deleted");
    }
  }

  public void release() { super.release(); discardShadow(); }

  public boolean canBeParent(ParentFigure parent) {
    return parent == null;
  }

}
