/*
 * @(#)ImageFigureCreationTool.java 5.1
 *
 */

package CH.ifa.draw.cpn;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.MouseEvent;
import java.io.*;

import CH.ifa.draw.figures.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.util.*;

public  class ImageFigureCreationTool extends CreationTool implements ImageObserver {

    private Image image;
    private String fImage = null;
    private Figure fImageFigure=null;
    private boolean waitForSize=false;


    public ImageFigureCreationTool(DrawingEditor editor) {
        super(editor);
    }

  public void activate() {
    super.activate();
    image=null;
        FileDialog dialog = new FileDialog(fEditor.menuFrame(), "Open Image...", FileDialog.LOAD);
        dialog.show();
        String filename = dialog.getFile();
        if (filename != null) {
	  //          filename = stripTrailingAsterisks(filename);
	    fImage = dialog.getDirectory() + filename;
        } else
	  fImage = null;
        dialog.dispose();

	if (fImage != null) {
	  image = Toolkit.getDefaultToolkit().getImage(fImage);
	  if (image!=null) {
	    MediaTracker tracker = new MediaTracker(fEditor.menuFrame());
	    tracker.addImage(image, 123);
	    // block until the image is loaded
	    try {
	      tracker.waitForAll();
	    } catch (Exception e) { image=null; }
	  }
	  if (image==null) {
	    System.out.println("Image "+fImage+" could not be loaded!");
	    fEditor.toolDone();
	  }
	}
  }


    /**
     * Creates a new ImageFigure.
     */
    protected Figure createFigure() {
        if (fImage != null && image != null) {
	  Point pnt=fEditor.view().lastClick();
	  return new ImageFigure(image, fImage, pnt);
	} else {
	  return null;
        }
    }

    public void mouseUp(MouseEvent e, int x, int y) { 
      Figure created = createdFigure();
      if (created!=null && created.isEmpty()) {
	Point loc = created.displayBox().getLocation();
	int width=image.getWidth(this),
	  height=image.getHeight(this);
	if (width==-1 || height==-1) {
	  System.out.println("Image not loaded properly!");
	} else {
	  created.displayBox(loc,new Point(loc.x+width,loc.y+height));
	}
      }
      super.mouseUp(e,x,y);
    }

    synchronized public boolean imageUpdate(Image img,
			       int infoflags,
			       int x,
			       int y,
			       int width,
			       int height) { 
      return false;
    }
}


