package CH.ifa.draw.cpn;

import java.awt.*;
import java.util.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import de.renew.simulator.*;
import collections.*;

public class TokenBagFigure extends TextFigure
implements Observer {
    public TokenBagFigure() {
        super();
    }

    private PlaceInstance placeInstance = null;

    void setPlaceInstance(PlaceInstance pi) {
       placeInstance = pi;
       if (tbv != null)
	 tbv.setPlaceInstance(pi);
       update(pi, null);
    }

  private int sizeCache = -1;
  private TokenBagView tbv = null;

  public void update(Observable oPlaceInstance,
			      Object freeTokens) {
    if (placeInstance != oPlaceInstance)
      placeInstance.deleteObserver(this);
    placeInstance = (PlaceInstance)oPlaceInstance;
    TokenBag myBag = placeInstance.getTokens();
    int newSize = myBag.getSize();
    if (newSize != sizeCache) {
       sizeCache = newSize;
       if (newSize > 0)
	 setText(String.valueOf(newSize));
       else
	 setText(" ");
       if (listener() != null)
          listener().figureRequestUpdate(new FigureChangeEvent(this));
    } /* endif */
    placeInstance.addObserver(this);
    if (tbv != null)
      tbv.notifyChange();
  }

  void windowClosed() {
    tbv = null;
  }

  public void inspect(DrawingView view) {
    if (tbv == null) {
      tbv = new TokenBagView(view,this,placeInstance);
    }
    tbv.show();
  }

  public void release() {
    if (placeInstance != null)
      placeInstance.deleteObserver(this);
    super.release();
  }

  public String toString() {
    StringBuffer output = new StringBuffer().append('{');
    TokenBag myBag = placeInstance.getTokens();
    CollectionEnumeration tokens = myBag.uniqueElements();
    while (tokens.hasMoreElements()) {
      Object token = tokens.nextElement();
      int mult = myBag.getMultiplicity(token);
      if (mult > 1)
         output.append(String.valueOf(mult)).append('');
      output.append(token.toString());
      if (tokens.hasMoreElements())
         output.append(", ");
    }
    output.append('}');
    return output.toString();
  }
}

