package CH.ifa.draw.cpn;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.framework.*;
import de.renew.simulator.*;

class TokenBagView implements ActionListener {

  private Frame frame;
  private List list;
  private DrawingView view;
  private TokenBagFigure tbf;
  private PlaceInstance pi;
  private Vector displayedTokens = new Vector();

  TokenBagView(DrawingView view, TokenBagFigure tobafi, PlaceInstance pi) {
    this.view = view;
    this.tbf = tobafi;
    this.pi = pi;
    frame = new Frame(pi.toString());
    list = new List(2);
    list.addActionListener(this);
    frame.add(list);
    frame.setLocation(tobafi.center());
    frame.pack();
    frame.setSize(100,frame.getSize().width);
    frame.addWindowListener(
      new WindowAdapter() {
        public void windowClosing(WindowEvent event) {
	  if (frame!=null) {
	    synchronized(frame) {
	      tbf.windowClosed();
	      frame.dispose();
	      frame = null;
	    }
	  }
	}
	// UGLY! Reimplement!
	public void windowClosed(WindowEvent event) {
	  windowClosing(event);
	}
      });
    notifyChange();
  }

  void setPlaceInstance(PlaceInstance pi) {
    this.pi = pi;
  }

  void notifyChange() {
    synchronized(frame) {
      if (frame != null) {
	if (list.getItemCount()>0) {
	  list.removeAll();
	}
	displayedTokens.removeAllElements();
	TokenBag myBag = pi.getTokens();
	Enumeration tokens = myBag.uniqueElements();
	while (tokens.hasMoreElements()) {
	  Object token = tokens.nextElement();
	  int mult = myBag.getMultiplicity(token);
	  String output = "";
	  if (mult > 1)
	    output = String.valueOf(mult) + "'";
	  output += token.toString();
	  list.add(output);
	  displayedTokens.addElement(token);
	}
	frame.show();
      }
    }
  }

  void show() { frame.show(); }


  public void actionPerformed(ActionEvent e) {
    Object token = displayedTokens.elementAt(list.getSelectedIndex());
    if (token instanceof NetInstance) {
      view.editor().showDrawingViewFrame(CPNInstanceDrawing.getDrawing((NetInstance)token));
    }
  }
}
