/*
 * @(#)TransitionFigureCreationTool.java 5.1
 *
 */

package CH.ifa.draw.cpn;

import java.awt.*;
import java.awt.event.MouseEvent;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;

/**
 * A more efficient version of the generic Trans creation
 * tool that is not based on cloning.
 */

public  class TransitionFigureCreationTool extends CreationTool {

    public TransitionFigureCreationTool(DrawingEditor editor) {
        super(editor);
    }

    /**
     * Creates a new TransitionFigure.
     */
    protected Figure createFigure() {
        return new TransitionFigure();
    }

    public void mouseUp(MouseEvent e, int x, int y) { 
      Figure created = createdFigure();
      if (created.isEmpty()) {
	Point loc = created.displayBox().getLocation();
        Dimension d = TransitionFigure.defaultDimension();
        int w2=d.width/2, h2=d.height/2;
        created.displayBox(new Point(loc.x-w2,loc.y-h2),
	  new Point(loc.x-w2+d.width,loc.y-h2+d.height));
      }
      super.mouseUp(e,x,y);
    }
}
