package de.renew.call;

import de.renew.simulator.*;
import de.renew.unify.*;

class BlockExecutable implements EarlyExecutable {
  SynchronisationRequest synchronisation;
  BlockExecutable(SynchronisationRequest synchronisation) {
    this.synchronisation=synchronisation;
  }

  public long phase() {
    return synchronisation.lockOrder;
  }

  public void lock() throws Impossible {
    synchronisation.lock.lock();
    if (synchronisation.completed) {
      synchronisation.lock.unlock();
      throw new Impossible();
    }
  }

  public void execute(Tracer tracer) {
    synchronisation.completed=true;
    synchronisation.lock.unlock();
  }

  public void unlock() {
    synchronisation.lock.unlock();
  }
}
