package de.renew.fs;

import collections.*;
import de.renew.unify.*;
import de.renew.simulator.*;
import fs.*;
import java.util.Vector;

public class FSComposeExpression implements Expression {
  FS template;
  Vector exprs;
  Vector feats;

  public FSComposeExpression(FS template, Vector exprs, Vector feats) {
    this.template=template;
    this.exprs=exprs;
    this.feats=feats;
  }

  public boolean isInvertible() {
    return false;
  }

  public Object startEvaluation(VariableMapper mapper, StateRecorder recorder, 
    CalculationChecker checker) throws Impossible
  {
    if (feats.size()>0) {
      FSComposer composer=new FSComposer(template,feats,recorder);
      
      for (int i=0;i<feats.size();i++) {
	Expression expr=(Expression)exprs.elementAt(i);
	Unify.unify(composer.getVariable(i),
	  expr.startEvaluation(mapper,recorder,checker),recorder);
      }
      
      return composer.result.getValue();
    } else {
      return template;
    }
  }

  public Object registerCalculation(VariableMapper mapper,
    StateRecorder recorder, CalculationChecker checker) throws Impossible
  {
    throw new Impossible("No FS composition in actions.");
  }
}

