package de.renew.fs;

import java.util.Vector;
import fs.*;
import de.renew.unify.*;

class FSComposer {
  Variable result;
  Vector variables= new Vector();
  FeatureStructure current;
  int open;

  FSComposer(FeatureStructure template, Vector feats, StateRecorder recorder)
    throws Impossible
  {
    result=new Variable();
    current=template;
    open=feats.size();

    // Create listeners.
    for (int i=0;i<feats.size();i++) {
      Variable variable = new Variable();
      variables.addElement(variable);
      setupListener(variable,(String)feats.elementAt(i),recorder);
    }
  }

  Variable getVariable(int i) { return (Variable)variables.elementAt(i); }

  void setupListener(final Variable variable, final String feat,
    StateRecorder recorder) throws Impossible
  {
    variable.addListener(new Notifiable() {
      public void boundNotify(StateRecorder recorder) throws Impossible {
	Object newVal=variable.getValue();
	final FeatureStructure oldCurrent=current;
	recorder.record(new StateRestorer() {
	  public void restore() {
	    current=oldCurrent;
	    open++;
	  }
	});
	open--;
	try {
	  current=current.unify(((FeatureStructure)newVal).pathFS(feat));
	} catch (UnificationFailure uff) {
	  throw new Impossible();
	}
	if (open==0) {
	  Unify.unify(result,current,recorder);
	}
      }
    },recorder);
  }
}
