package de.renew.function;

import de.renew.unify.*;
import java.lang.reflect.*;

public class FieldWriteFunction implements de.renew.unify.Function {
  Object field;

  public FieldWriteFunction(String field) {
    this.field=field;
  }

  public FieldWriteFunction(Field field) {
    this.field=field;
  }

  public Object function(Object param) throws Impossible {
    try {
      // param must be a tuple consisting of the object
      // and the new value.
      Tuple tuple=(Tuple)param;
      Object obj=tuple.getComponent(0);
      Object val=tuple.getComponent(1);

      // Unlike in FieldFunction we need not deal with the special
      // field length for arrays, which cannot be assigned.
      Field theField;
      if (field instanceof String) {
	theField=obj.getClass().getField((String)field);
      } else {
	theField=(Field)field;
      }

      // Possibly unwrap, then assign.
      theField.set(Executor.unvalueAndCast(obj,theField.getType()),val);

      // Return the assigned value.
      return val;
    }
    catch (Exception e) {
      throw new Impossible();
    }
  }
}
