package de.renew.shadow;

import collections.*;
import de.renew.simulator.Arc;
 
public class ShadowArc implements ShadowNetElement {
  public static final int test=0;
  public static final int ordinary=1;
  public static final int both=2;
  
  public ShadowTransition transition;
  public ShadowPlace place;
  public String inscription;
  boolean trace;
  // The arc type is determined by the constants in class de.renew.simulator.Arc.
  public int arcType;

  public ShadowArc(ShadowNetElement from, ShadowNetElement to,
    int shadowArcType, String inscription)
  {
    if (from instanceof ShadowTransition) {
      if (to instanceof ShadowPlace) {
	transition=(ShadowTransition)from;
	place=(ShadowPlace)to;
	arcType=Arc.out;
      } else {
	throw new RuntimeException("Must connect place and transition.");
      }
    } else if (from instanceof ShadowPlace) {
      if (to instanceof ShadowTransition) {
	transition=(ShadowTransition)to;
	place=(ShadowPlace)from;
	arcType=Arc.in;
      } else {
	throw new RuntimeException("Must connect place and transition.");
      }
    } else {
      throw new RuntimeException("Must connect place and transition.");
    }
    if (transition.shadowNet!=place.shadowNet) {
      throw new RuntimeException("Must connect within one net.");
    }

    // Check the shadow arc type.
    switch (shadowArcType) {
    case test:
      arcType=Arc.test;
      break;
    case both:
      arcType=Arc.both;
      break;
    case ordinary:
      // The arc type has already been determined.
      break;
    default:
      throw new RuntimeException("Bad shadow arc type: "+shadowArcType+".");
    }

    // Ok, remember the inscription.
    this.inscription=inscription;
    trace=true;
    transition.add(this);
  }

  public ShadowArc(ShadowNetElement from, ShadowNetElement to,
    String inscription) throws SyntaxException 
  {
    this(from,to,ordinary,inscription);
  }

  public void syntaxCheck() throws SyntaxException {
    transition.shadowNet.netSystem.compiler.checkArcInscription(inscription,
      transition.shadowNet);
  }

  public void setTrace(boolean trace) {
    if (this.trace!=trace) {
      this.trace=trace;
      transition.shadowNet.changeNotify();
    }
  }

  public boolean getTrace() {
    return trace;
  }

  public void discard() {
    transition.remove(this);
  }
}
