package de.renew.shadow;

import collections.*;

public class ShadowInscription implements ShadowNetElement {
  public final ShadowNode node;
  public final String inscr;
  boolean trace;
  
  public ShadowInscription(ShadowTransition transition, String inscr) {
    this.node=transition;
    this.inscr=inscr;
    transition.add(this);
  }

  public ShadowInscription(ShadowPlace place, String inscr) {
    this.node=place;
    this.inscr=inscr;
    place.add(this);
  }

  public void syntaxCheck() throws SyntaxException {
    if (node instanceof ShadowTransition) {
      node.shadowNet.netSystem.compiler.checkTransitionInscription(inscr,
	node.shadowNet);
    } else {
      // assert(node instanceof ShadowPlace);
      node.shadowNet.netSystem.compiler.checkPlaceInscription(inscr,
	node.shadowNet);
    }
  }

  public void setTrace(boolean trace) {
    if (this.trace!=trace) {
      this.trace=trace;
      node.shadowNet.changeNotify();
    }
  }

  public boolean getTrace() {
    return trace;
  }

  public void discard() {
    node.remove(this);
  } 
}
