package de.renew.shadow;

import collections.*;
import java.util.Hashtable;

public class ShadowNet {
  private UpdatableSet elements;
  private String name;
  ShadowNetSystem netSystem;

  public ShadowNet(String name, ShadowNetSystem netSystem) {
    elements=new HashedSet();
    this.name=name;
    this.netSystem=netSystem;
    netSystem.add(this);
  }

  void changeNotify() {
    netSystem.changeNotify();
  }

  public void setName(String name) {
    this.name=name;
    netSystem.changeNotify();
  }
  public String getName() {
    return name;
  }
  public CollectionEnumeration elements() {
    return elements.elements();
  }

  public void discard() {
    netSystem.remove(this);
  }

  void add(ShadowNetElement element) {
    elements.include(element);
    netSystem.changeNotify();
  }
  void remove(ShadowNetElement element) {
    elements.exclude(element);
    netSystem.changeNotify();
  }
}

