package de.renew.shadow;

import collections.*;
import java.util.Hashtable;

public class ShadowNetSystem {
  UpdatableSet nets;
  ShadowCompiler compiler;
  private boolean hasChanged;

  public ShadowNetSystem(ShadowCompiler compiler) {
    this.compiler=compiler;
    nets=new HashedSet();
    changeNotify();
  }

  public ShadowNetSystem() {
    this(new de.renew.java.JavaNetCompiler());
  }

  // Add and remove nets.
  void add(ShadowNet net) {
    nets.include(net);
    changeNotify();
  }
  void remove(ShadowNet net) {
    nets.exclude(net);
    changeNotify();
  }

  public boolean hasChanged() {
    return hasChanged;
  }

  void changeNotify() {
    hasChanged=true;
  }

  public ShadowLookup compile() throws SyntaxException {    
    hasChanged=false;
    return compiler.compile(this);
  }

  public CollectionEnumeration elements() {
    return nets.elements();
  }
}
