package de.renew.shadow;

import collections.*;

public abstract class ShadowNode implements ShadowNetElement {
  UpdatableSet elements;
  public final ShadowNet shadowNet;
  String name;

  ShadowNode(ShadowNet shadowNet) {
    this.shadowNet=shadowNet;
    elements=new HashedSet();
    name=null;
    shadowNet.add(this);
  }

  void add(ShadowNetElement element) {
    elements.include(element);
    shadowNet.changeNotify();
  }
  void remove(ShadowNetElement element) {
    elements.exclude(element);
    shadowNet.changeNotify();
  }

  public void discard() {
    shadowNet.remove(this);
  }

  public CollectionEnumeration elements() {
    return elements.elements();
  }

  public void setName(String name) {
    this.name=name;
    shadowNet.changeNotify();
  }

  public String getName() {
    return name;
  }
}
