package de.renew.simulator;

import collections.*;
import de.renew.util.*;
import de.renew.unify.*;

class ActionOccurrence implements ExecutableOccurrence {
  ActionInscription actionInscription;
  VariableMapper mapper;

  ActionOccurrence(ActionInscription actionInscription,
    VariableMapper mapper)
  {
    this.actionInscription=actionInscription;
    this.mapper=mapper;
  }
  
  public CollectionEnumeration makeBinders(Searcher searcher)
    throws Impossible
  {
    actionInscription.expression.registerCalculation(mapper,
      searcher.currentStateRecorder,searcher.calcChecker);
    // That's it. No binders required.
    return new EmptyEnumeration();
  }

  public CollectionEnumeration makeExecutables(Copier copier,
    VariableMapper copiedMapper) 
  {
    return new SingletonEnumeration(
      new ActionExecutable(actionInscription,copiedMapper));
  }
}
