package de.renew.simulator;

import collections.*;

public class Arc implements ExecutableInscription {
  public static final int in=-1;
  public static final int test=0;
  public static final int out=1;
  public static final int both=2;

  Place place;
  int arcType;
  Expression expression;
  boolean trace;

  public Arc(Place place, int arcType, Expression expression) {
    if (arcType!=in && arcType!=test && arcType!=out && arcType!=both) {
      throw new RuntimeException("Bad arc type: "+arcType+".");
    }
    this.place=place;
    this.arcType=arcType;
    this.expression=expression;
    trace=true;
  }

  public void setTrace(boolean trace) {
    this.trace=trace;
  }

  public boolean getTrace() {
    return trace;
  }

  public InscriptionOccurrence makeOccurrence(VariableMapper mapper, 
    TransitionInstance transitionInstance)
  {
    return new ArcOccurrence(this,mapper,
      transitionInstance);
  }
}

