package de.renew.simulator;

import java.util.Hashtable;

final class ChannelType {
  static Hashtable instances=new Hashtable();

  public final int arity;
  public final String name;

  private ChannelType(int arity, String name) {
    this.arity=arity;
    this.name=name.intern();
  }
  static ChannelType create(String name, int arity) {
    name=name.intern();
    ChannelType newChannel=new ChannelType(arity,name);
    if (instances.containsKey(newChannel)) {
      return (ChannelType)instances.get(newChannel);
    } else {
      instances.put(newChannel,newChannel);
      return newChannel;
    }
  }
  public boolean equals(Object obj) {
    if (obj instanceof ChannelType) {
      ChannelType other=(ChannelType) obj;
      if (arity!=other.arity) {
	return false;
      }
      return (name==other.name);
    } else {
      return false;
    }
  }
  public int hashCode() {
    return name.hashCode()+arity;
  }
}

