package de.renew.simulator;

import collections.*;
import de.renew.util.*;
import de.renew.unify.*;
import de.renew.util.*;

class DownlinkOccurrence implements InscriptionOccurrence {
  DownlinkInscription downlinkInscription;
  VariableMapper mapper;
  TransitionInstance initiatingTransition;

  DownlinkOccurrence(DownlinkInscription downlinkInscription,
    VariableMapper mapper, TransitionInstance initiatingTransition)
  {
    this.downlinkInscription=downlinkInscription;
    this.mapper=mapper;
    this.initiatingTransition=initiatingTransition;
  }
  
  public CollectionEnumeration makeBinders(Searcher searcher)
    throws Impossible
  {
    Variable callee=new Variable(
      downlinkInscription.callee.startEvaluation(mapper,
	searcher.currentStateRecorder,searcher.calcChecker),
	searcher.currentStateRecorder);
    Variable params=new Variable(
      downlinkInscription.params.startEvaluation(mapper,
	searcher.currentStateRecorder,searcher.calcChecker),
	searcher.currentStateRecorder);
    
    return new SingletonEnumeration(
      new NetChannelBinder(callee,downlinkInscription.name,params,
	downlinkInscription.isOptional,initiatingTransition));
  }
}
