package de.renew.simulator;

import collections.*;
import de.renew.unify.Impossible;

// Classes should never implement this interface directly, but rather
// EarlyExecutable of LateExecutable.
interface Executable {
  // Get the phase during which this executable should execute.
  // If the phase is less than or equal to 0, the executable
  // must implement the interface EarlyExecutable. If the
  // phase is greater than 0, the executable must implement
  // the interface LateExecutable.
  long phase();

  // Execute this executable.
  void execute(Tracer tracer) throws Impossible;
}
