package de.renew.simulator;

import collections.*;

class ListenerCollection implements Listener {
  // Keep track of notified objects.
  private UpdatableSet listeners;
  // Keep track of sequence of notification.
  private UpdatableSeq list;

  public ListenerCollection() {
    listeners=new HashedSet();
    list=new CircularList();
  }

  public void includeListener(Listener listener) {
    if (!listeners.includes(listener)) {
      listeners.include(listener);
      list.insertLast(listener);
    }
  }

  public void notifyChange() {
    // Get the listeners.
    CollectionEnumeration enum=list.elements();
    // Forget the listeners, so that cyclic listener
    // notifications are impossible. (Should not
    // occur anyway, but there might be occasions
    // where this comes handy.)
    listeners=new HashedSet();
    list=new CircularList();
    // Send the notifications.
    while (enum.hasMoreElements()) {
      ((Listener)enum.nextElement()).notifyChange();
    }
  }
}
