package de.renew.simulator;

import collections.*;
import de.renew.unify.*;

class OutputArcExecutable implements LateExecutable {
  PlaceInstance placeInstance;
  Variable token;
  boolean trace;

  OutputArcExecutable(PlaceInstance placeInstance, Variable token,
    boolean trace)
  {
    this.placeInstance=placeInstance;
    this.token=token;
    this.trace=trace;
  }

  public long phase() {
    return 2L;
  }

  // We can put a token in an output place quickly.
  public boolean isLong() {
    return false;
  }

  public void execute(Tracer tracer) {
    if (trace) {
      tracer.trace("    Putting "+token.getValue()+
	" into "+placeInstance);
    }
    placeInstance.insertToken(token.getValue());
  }
}
