package de.renew.simulator;

public interface Simulator {
  public NetInstance getPrimaryInstance();

  // Return true, if the simulation could possibly
  // continue in the future.
  public boolean isActive();

  // Start the simulation in the background.
  public void startRun();

  // Gently stop the simulation.
  public void stopRun();

  // Stop the simulation the hard way.
  // This may corrupt the simulation state.
  public void terminateRun();

  // Perform just one step or terminate the simulation, if
  // it is running in the background. Return true, if
  // another binding could be found.
  public boolean step();
}



