package de.renew.simulator;

import collections.*;
import de.renew.unify.*;

class TestArcExecutable implements EarlyExecutable {
  PlaceInstance placeInstance;
  Object token;
  boolean trace;

  TestArcExecutable(PlaceInstance placeInstance, Object token,
    boolean trace)
  {
    this.placeInstance=placeInstance;
    this.token=token;
    this.trace=trace;
  }

  public long phase() {
    return placeInstance.lockOrder;
  }

  public void lock() throws Impossible {
    placeInstance.lock.lock();
    try {
      placeInstance.testToken(token);
    }
    catch (Exception e) {
      placeInstance.lock.unlock();
      // No reservation actually took place.
      throw new Impossible();
    }
  }

  public void execute(Tracer tracer) {
    if (trace) {
      tracer.trace("    Testing "+token+" in "+placeInstance);
    }
    placeInstance.untestToken(token);
    placeInstance.lock.unlock();
  }

  public void unlock() {
    placeInstance.untestToken(token);
    placeInstance.lock.unlock();
  }
}
