package de.renew.simulator;

import collections.*;

/**
 * I am the token listener interface. Upon request,
 * my childern will provide a set of object that
 * are contained in a place. They might make special
 * restrictions on the tokens, e.g., only a special type,
 * only testable tokens, only free tokens, etc.
 **/
interface TokenLister {
  /**
   * Here I provide a set of tokens.
   *
   * @return an enumeration with the possible different tokens.
   **/
  CollectionEnumeration getDistinctTokens();
}
