package de.renew.simulator;

import de.renew.unify.Tuple;

/**
 * I represent an uplink that can be inscribed to a transition.
 * I do not do anything, except remembering my name
 * and my argument expression.
 *
 * @author Olaf Kummer
 **/
public class UplinkInscription implements TransitionInscription {
  /**
   * My name.
   **/
  String name;
  /**
   * My argument expression. Typically this is a tuple expression.
   **/
  Expression params;
 
  /**
   * I (an uplink inscription) am created. I will store
   * the given name and expression
   * for later retrieval.
   * 
   * @param name
   *   the name of the channel that I represent
   * @param params
   *   the expression that must match the expression
   *   of the respective uplink
   **/
  public UplinkInscription(String name, Expression params) {
    this.name=name;
    this.params=params;
  }
}
