package de.renew.unify;

public final class Tuple extends Carrier {
  public Tuple(int arity) {
    super(Unify.makeUnknownArray(arity),null);
  }

  public Tuple(Object[] initValues, StateRecorder recorder) {
    super(Unify.cleanupArray(initValues),recorder);
  }

  public int getArity() {
    return arity;
  }

  public Object getComponent(int i) {
    return references[i];
  }

  public int hashCode() {
    int result=references.length+71;

    for (int i=0;i<references.length;i++) {
      if (references[i]==null) {
	result=result*41+1;
      } else {
	result=result*41+references[i].hashCode();
      }
    }

    return result;
  }

  public boolean equals(Object obj) {
    if (!(obj instanceof Tuple)) {
      return false;
    }
    
    Tuple that=(Tuple)obj;
    if (references.length!=that.references.length) {
      return false;
    }

    for (int i=0;i<references.length;i++) {
      if (references[i]==null) {
        if (that.references[i]!=null) {
          return false;
        }
      } else {
        if (!references[i].equals(that.references[i])) {
          return false;
        }
      }
    }

    return true;
  }

  public String toString() {
    StringBuffer result=new StringBuffer();
    result.append('[');
    for (int i=0;i<references.length;i++) {
      if (i>0) {
        result.append(',');
      }
      if (references[i]==null) {
	result.append("null");
      } else {
	result.append(references[i].toString());
      }
    }
    result.append(']');
    return result.toString();
  }
}
