package de.renew.util;

public class Lock {
  private Thread lockingThread;
  private int lockCount;
  public Lock() {
    lockingThread=null;
    lockCount=0;
  }
  public synchronized void lock() {
    Thread currentThread=Thread.currentThread();
    while (lockingThread!=null && lockingThread!=currentThread) {
      try {
	wait();
      } catch (InterruptedException e) {}
    }
    
    lockingThread=currentThread;
    lockCount++;
  }
  public synchronized void unlock() {
    Thread currentThread=Thread.currentThread();
    if (currentThread!=lockingThread) {
      throw new RuntimeException("Lock/unlock mismatch.");
    }
    lockCount--;
    if (lockCount==0) {
      lockingThread=null;
    }
    notify();
  }
}
