package de.renew.util;

import collections.CollectionEnumeration;

// I convert nulls to and from an internal representation,
// so that the collection classes do not need to treat
// nulls explicitly.

public class Null {
  private static Object NULL=new Object();

  // Convert a single object.
  public final static Object convert(Object obj) {
    if (obj==null) {
      return NULL;
    } else if (obj==NULL) {
      return null;
    }
    return obj;
  }

  // Convert an enumeration. I simply put a wrapper object around
  // the original enumeration.
  public final static CollectionEnumeration convertEnumeration(
    CollectionEnumeration enum)
  {
    return new NullEnumeration(enum);
  }
}
