package fs;

import CH.ifa.draw.framework.Figure;
import CH.ifa.draw.figures.*;

public class IsaConnection extends LineConnection {

    public IsaConnection() {
      setStartDecoration(null);
      setEndDecoration(new ArrowTip());
    }

    private static ConceptImpl getConcept(Figure figure) {
      if (!(figure instanceof ConceptFigure)) return null;
      return ((ConceptFigure)figure).getConcept();
    }

    public void handleConnect(Figure start, Figure end) {
      try {
	getConcept(start).addIsa(getConcept(end));
	//	System.err.println("Concept "+getConcept(start)+" is a "+getConcept(end));
      } catch (CyclicHierarchyException e) {
	System.err.println("Cyclic hierarchy!");
      }
    }

    public void handleDisconnect(Figure start, Figure end) {
      //System.err.println("isa-Disconnect!");
      ConceptImpl subconcept = getConcept(start), superconcept = getConcept(end);
      if (subconcept != null && superconcept != null) {
        subconcept.removeIsa(superconcept);
	//        System.err.println("Concept "+getConcept(start)+" is no more a "+getConcept(end));
      } else {
	//        System.err.println("start: "+getConcept(start)+", end: "+getConcept(end));
      }
   }

    public boolean canConnect(Figure start, Figure end) {
      Concept subconcept = getConcept(start), superconcept = getConcept(end);
      if (subconcept != null && superconcept != null)
	  return !(subconcept.isa(superconcept)
		   || superconcept.isa(subconcept));
	else
	  return false;
    }

    public void release() { super.release(); }
  // wird handleDisconnect aufgerufen?

    public void setAttribute(String name, Object value) {
      if (!name.equals("ArrowMode")) {
         super.setAttribute(name,value);
      }
    }

}
