package fs;

import java.io.*;
import java.awt.*;
import java.util.Vector;
import CH.ifa.draw.figures.RectangleFigure;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.util.ColorMap;
import CH.ifa.draw.standard.*;

public class PartitionFigure extends RectangleFigure {

    /*
     * Serialization support.
     */
    private static final long serialVersionUID = 184722075881789136L;
    private int rectangleFigureSerializedDataVersion = 1;

  protected Partition partition = new Partition();

  public PartitionFigure() {
    super();
    setAttribute("FrameColor", ColorMap.color("Black"));
    setAttribute("FillColor", ColorMap.color("Blue"));
  }

  public Partition getPartition() { return partition; }

  private boolean tryUpdate(ChildFigure child) {
     if (child instanceof ConceptFigure) {
        ConceptImpl con = ((ConceptFigure)child).getConcept();
        if (con != null) {
           try { partition.addConcept(con);
           } catch (UnificationFailure te) { return false; }
        }
     }
     return true;
  }

  public void addChild(ChildFigure child) {
     if (tryUpdate(child))
        super.addChild(child);
  }

  public void childChanged(ChildFigure child) {
     tryUpdate(child);
     super.childChanged(child);
  }

  public void removeChild(ChildFigure child) {
     super.removeChild(child);
     ConceptImpl con = ((ConceptFigure)child).getConcept();
     partition.removeConcept(con);
  }

  public void release() {
    super.release();
    partition.remove();
    partition = null;
  }

}
